 
 //---------------------------------------------- CREATION ---------------------------------------------------------------

function world_creation()
{
    //World Creation          
    for (i=0;i<256;i++)
    {
        ground[i] = new Array(256);
        middle[i] = new Array(256);
        value[i] = new Array(256);
        for (j=0;j<256;j++) 
        {
            middle[i][j]=0;//parseInt(Math.random()*1000)%12;
            value[i][j]=0;//parseInt(Math.random()*1000)%12;
        }
        //Peon Init
        peon[i] = new Array();
        peon[i]["modus"]=0;
        peon[i]["food"]=0;
        peon[i]["wood"]=0;
        peon[i]["gold"]=0;
        peon[i]["iron"]=0;
        peon[i]["stone"]=0;
        peon[i]["ctr"]=0;
        peon[i]["x32"]=0;
        peon[i]["y16"]=0;
        peon[i]["dx"]=-1;
        peon[i]["dy"]=-1;            
        peon[i]["dir"]=4;            
        peon[i]["rx"]=-1;
        peon[i]["ry"]=-1;            
        peon[i]["typ"]=0;
        peon[i]["x"]=0;
        peon[i]["y"]=0;
        peon[i]["live"]=0;
        peon[i]["maxlive"]=0;
        peon[i]["range"]=0;
        peon[i]["damage"]=0;
        peon[i]["target"]=-1;
        peon[i]["shotx"]=-1;
        peon[i]["shoty"]=-1;
        peon[i]["shotlen"]=-1;
        peon[i]["stance"]=0;//0:stay ground, 1:attack
        peon[i]["healctr"]=0;
        peon[i]["blockctr"]=0;
        peon[i]["mana"]=0;
        peon[i]["veteran"]=0;
        peon[i]["kills"]=0;
        peon[i]["reloadctr"]=0;
        peon[i]["helm"]=0;//v0076 Item patch
        peon[i]["chest"]=0;
        peon[i]["gauntlets"]=0;
        peon[i]["pants"]=0;
        peon[i]["shoes"]=0;
        peon[i]["ring"]=0;
        peon[i]["amulet"]=0;
        peon[i]["weapon"]=0;
        peon[i]["shield"]=0;
        peon[i]["backpack"]=0;//htg array ?
        peon[i]["questitem"]=0;
        //TC Init
        tc[i] = new Array();
        tc[i]["modus"]=1;
        tc[i]["typ"]=0;
        tc[i]["menu"] = new Array(4);
        for (j=0;j<4;j++)tc[i]["menu"][j] = 0;
        tc[i]["order"]=-1;
        tc[i]["orderctr"]=0;             
        tc[i]["animctr"]=0;
    }           
    
    //MOB Init
    for (i=0;i<1024*8;i++)
    {
        mob[i] = new Array();
        mob[i]["modus"]=0;
        mob[i]["ctr"]=0;
        mob[i]["size"]=0;
        mob[i]["x32"]=0;
        mob[i]["y16"]=0;
        mob[i]["dx"]=-1;
        mob[i]["dy"]=-1;            
        mob[i]["dir"]=4;            
        mob[i]["target"]=-1;
        //mob[i]["stunned"]=0;    //htg     idle ?      
        mob[i]["typ"]=0;
        mob[i]["x"]=0;
        mob[i]["y"]=0;
        mob[i]["live"]=0;
        mob[i]["range"]=0;
        mob[i]["damage"]=0;          
        mob[i]["idle"]=0;       
        mob[i]["mana"]=0;     
        mob[i]["spawned"]=0;    
        mob[i]["shotx"]=-1;
        mob[i]["shoty"]=-1;
        mob[i]["shotlen"]=-1;   
        mob[i]["gold"]=0;       
        mob[i]["item"]=0;       
    }
    startsectorx=2+parseInt(Math.random()*1000)%12;
    startsectory=2+parseInt(Math.random()*1000)%12;
    
    startposx=startsectorx*16+8
    startposy=startsectory*16+8 
    //Sector Init
    for (si=0;si<16;si++)
    {
        sector[si] = new Array(16);
        for (sj=0;sj<16;sj++) 
        {                  
            
            sector[si][sj]=0;//parseInt(Math.random()*1000)%16;
            i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;         
            stones=3+parseInt(Math.random()*1000)%8;
            for (i=0;i<16;i++)
            {                   
                for (j=0;j<16;j++) 
                {
                      if (lvl>10)  
                      {
                          if (lvl>14)  
                          {
                              ground[si*16+i][sj*16+j]=-13-parseInt(Math.random()*1000)%2;
                          } else
//                          if (lvl>13)  //maybe later
//                          {
//                              ground[si*16+i][sj*16+j]=-11-parseInt(Math.random()*1000)%2;
//                          } else
                          {
                             if (parseInt(Math.random()*1000)%4==0)
                             {
                                ground[si*16+i][sj*16+j]=-21-parseInt(Math.random()*1000)%7;
                             } else
                                ground[si*16+i][sj*16+j]=-28-parseInt(Math.random()*1000)%3;
                          }
                      } else
                      {
                         if (parseInt(Math.random()*1000)%stones==0)
                         {
                             ground[si*16+i][sj*16+j]=16+parseInt(Math.random()*1000)%16;
                         } else ground[si*16+i][sj*16+j]=parseInt(Math.random()*1000)%16;
                     }
                }
            }
        }
    }      
      
    sector[startsectorx][startsectory]=1;//Starting point player
    px=startposx;
    py=startposy;
    pdx=px;
    pdy=py;
    //Activate one Towncenter TC
    tc[0]["modus"]=1;    
    tc[0]["typ"]=10;
    tc[0]["live"]=tctyp[tc[0]["typ"]]["live"];
    tc[0]["x"]=startposx;
    tc[0]["y"]=startposy;
    tc[0]["order"]=0;
    tc[0]["orderlist"]=new Array();
    tc[0]["dx"]=startposx+2;
    tc[0]["dy"]=startposy+2; 
    middle[startposx][startposy]=3000;            //Building nr 0
   // middle[startposx+4][startposy]=34;            //Test
    //Ground 
    for (i=startposx-2;i<startposx+3;i++)for (j=startposy-2;j<startposy+3;j++) ground[i][j]=16+parseInt(Math.random()*1000)%8;
    
    //Activate some population
    for (i=0;i<MaxPeon;i++)
    {
        peon[i]["modus"]=5;//materializing
        peon[i]["ctr"]=-1;
        switch (i)
        {
            case 1: peon[i]["typ"]=0;break;
            case 2: peon[i]["typ"]=0;break;
            case 3: peon[i]["typ"]=1;break;
            case 4: peon[i]["typ"]=3;break;
            case 0: peon[i]["typ"]=8;peon[i]["mana"]=10;break;//8
        }
        peon[i]["x"]=startposx+2;
        peon[i]["y"]=startposy-2+i;
        peon[i]["live"]= peontyp[peon[i]["typ"]]["live"];        
        peon[i]["maxlive"]=peon[i]["live"];
        peon[i]["damage"]= peontyp[peon[i]["typ"]]["damage"];
        peon[i]["range"]= peontyp[peon[i]["typ"]]["range"];
        middle[peon[i]["x"]][peon[i]["y"]]=2000+i; 
        
        
    }
    //ground[startposx-2][startposy-2]=-17-5;            //porter test
    
    //middle[peon[0]["x"]][peon[0]["y"]]=1090+peon[0]["dir"]*15+round%8;
    
    //Mines
    for (m=0;m<3;m++) for (r=0;r<6;r++) //stone gold iron 2 x ranges not in desert zone
    {        
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>0+r*2)&&(i+j<2+r*2))
                {
                    sector[sectorx2][sectory2] = 4+m;
                    okctr++;
                    posx2=sectorx2*16+4+parseInt(Math.random()*1000)%8;
                    posy2=sectory2*16+4+parseInt(Math.random()*1000)%8;
                    middle[posx2][posy2]=1000+5*16+4+m;
                    value[posx2][posy2]=10000;                         
                    //Ground 
                    for (i=posx2-1;i<posx2+2;i++)for (j=posy2-1;j<posy2+2;j++) ground[i][j]=16+parseInt(Math.random()*1000)%8;                    
                }
            }
            ctr++;
        }
    }

    //Mana Point
    for (r=0;r<5;r++) // 2 x ranges
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
               // if  ((i+j>2+r*2)&&(i+j<4+r*2))//TEST
                if  ((i+j>2+r*2)&&(i+j<4+r*2))
                {
                    sector[sectorx2][sectory2] = 7;
                    okctr++;
                    posx2=sectorx2*16+4+parseInt(Math.random()*1000)%8;
                    posy2=sectory2*16+4+parseInt(Math.random()*1000)%8;
                    middle[posx2][posy2]=1000+22*16;
                    value[posx2][posy2]=10000;                         
                    //Ground 
                    for (i=posx2-2;i<posx2+3;i++)for (j=posy2-2;j<posy2+3;j++) ground[i][j]=16+parseInt(Math.random()*1000)%8;                    
                    //Corner Stones
                    middle[posx2-2][posy2-2]=1000+23*16;  
                    middle[posx2-2][posy2+2]=1000+23*16;
                    middle[posx2+2][posy2-2]=1000+23*16;
                    middle[posx2+2][posy2+2]=1000+23*16;
                }
            }
            ctr++;
        }
    }
    //NPC & hut
    for (r=0;r<2;r++) // 4 x ranges
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=3+r*4)&&(i+j<4+r*4))
                {
                    sector[sectorx2][sectory2] = 8;
                    okctr++;
                    posx2=sectorx2*16+4+parseInt(Math.random()*1000)%8;
                    posy2=sectory2*16+4+parseInt(Math.random()*1000)%8;
                    middle[posx2][posy2]=17;//1000+21*16;//htg lost tower quest
                    value[posx2][posy2]=10000;          
                    
                    npc[1+r]["modus"]=1;//activate Durga
                    npc[1+r]["x"]=posx2+2;
                    npc[1+r]["y"]=posy2+0;
//                    if (r==1)
//                    {
//                        npc[1+r]["x"]=startposx+4;//TEST
//                        npc[1+r]["y"]=startposy+4;
//                    }
                    middle[npc[1+r]["x"]][npc[1+r]["y"]]=1000+npc[1+r]["animation"];
                    //Ground 
                    for (i=posx2-2;i<posx2+3;i++)for (j=posy2-2;j<posy2+3;j++) ground[i][j]=16+parseInt(Math.random()*1000)%8;                    
                    //Corner Stones
                    middle[posx2-2][posy2-2]=1000+23*16;  
                    middle[posx2-2][posy2+2]=1000+23*16;
                    middle[posx2+2][posy2-2]=1000+23*16;
                    middle[posx2+2][posy2+2]=1000+23*16;
                }
            }
            ctr++;
        }
    }
    //smith npc
    //for (r=0;r<2;r++) // 4 x ranges
    r=0;
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=2+r*4)&&(i+j<3+r*4))
                {
                    sector[sectorx2][sectory2] = 16;
                    okctr++;
                    posx2=sectorx2*16+4+parseInt(Math.random()*1000)%8;
                    posy2=sectory2*16+4+parseInt(Math.random()*1000)%8;
                    middle[posx2][posy2]=2;//smith shop
                    value[posx2][posy2]=10000;          
                    
                    npc[0]["modus"]=1;//activate smith
                    npc[0]["x"]=posx2-1;
                    npc[0]["y"]=posy2+1;
                    middle[npc[0]["x"]][npc[0]["y"]]=1000+npc[0]["animation"];
                    //Ground 
                    for (i=posx2-2;i<posx2+3;i++)for (j=posy2-2;j<posy2+3;j++) ground[i][j]=16+parseInt(Math.random()*1000)%8;                    
                    //Corner Stones
//                    middle[posx2-2][posy2-2]=1000+23*16;  
//                    middle[posx2-2][posy2+2]=1000+23*16;
//                    middle[posx2+2][posy2-2]=1000+23*16;
//                    middle[posx2+2][posy2+2]=1000+23*16;
                }
            }
            ctr++;
        }
    }
    //Sarwaswati
    //for (r=0;r<2;r++) // 4 x ranges
    r=0;
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=1+r*4)&&(i+j<2+r*4))
                {
                    sector[sectorx2][sectory2] = 18;
                    okctr++;
                    posx2=sectorx2*16+4+parseInt(Math.random()*1000)%8;
                    posy2=sectory2*16+4+parseInt(Math.random()*1000)%8;
                    middle[posx2][posy2]=36;//Alchemist hut
                    value[posx2][posy2]=10000;          
                    
                    npc[3]["modus"]=1;//activate npc
                    npc[3]["x"]=posx2-1;
                    npc[3]["y"]=posy2+1;
                    middle[npc[0]["x"]][npc[0]["y"]]=1000+npc[0]["animation"];
                    //Ground 
                    for (i=posx2-2;i<posx2+3;i++)for (j=posy2-2;j<posy2+3;j++) ground[i][j]=16+parseInt(Math.random()*1000)%8;                    
                    //Corner Stones
//                    middle[posx2-2][posy2-2]=1000+23*16;  
//                    middle[posx2-2][posy2+2]=1000+23*16;
//                    middle[posx2+2][posy2-2]=1000+23*16;
//                    middle[posx2+2][posy2+2]=1000+23*16;
                }
            }
            ctr++;
        }
    }
    //Dwarf Villages
    for (r=0;r<3;r++) // 1 x ranges
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=6+r)&&(i+j<7+r))
                {
                    sector[sectorx2][sectory2] = 19;
                    warsectorx[r]=sectorx2;
                    warsectory[r]=sectory2;
                    okctr++;
                    posx2=sectorx2*16+8;
                    posy2=sectory2*16+8;
                    
                    value[posx2-1][posy2-1]=r;          
                    middle[posx2-1][posy2-1]=60032;//Standarte
                    if (r==2) middle[posx2-1][posy2-1]=60033;//Standarte 2
                    //Ground 
                    for (i=posx2-2;i<posx2+3;i++)for (j=posy2-2;j<posy2+3;j++) ground[i][j]=16+parseInt(Math.random()*1000)%8;                    
                    //Corner Stones
                    m=6;
//                    middle[posx2-m][posy2-m]=3;  
//                    middle[posx2-m][posy2+m]=3;
//                    middle[posx2+m][posy2-m]=3;
//                    middle[posx2+m][posy2+m]=3;
//                    middle[posx2-m+1][posy2-m]=3;  
//                    middle[posx2-m+1][posy2+m]=3;
//                    middle[posx2+m-1][posy2-m]=3;
//                    middle[posx2+m-1][posy2+m]=3;
//                    middle[posx2-m][posy2-m+1]=3;  
//                    middle[posx2-m][posy2+m-1]=3;
//                    middle[posx2+m][posy2-m+1]=3;
//                    middle[posx2+m][posy2+m-1]=3;
                }
            }
            ctr++;
        }
    }
    
    //Dark Fortress
    for (r=0;r<1;r++) // 1 x ranges
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=10+r)&&(i+j<11+r))
                {
                    sector[sectorx2][sectory2] = 20;
                    warsectorx[3]=sectorx2;
                    warsectory[3]=sectory2;
                    okctr++;
                    posx2=sectorx2*16+8;
                    posy2=sectory2*16+8;                    
                    value[posx2-1][posy2-1]=1000;          
                    middle[posx2-1][posy2-1]=3;//Castle
                    value[posx2+2][posy2+2]=0;          
                    middle[posx2+2][posy2+2]=60048;//Asian Grave spawns wizards
                    //Ground 
                    for (i=posx2-2;i<posx2+3;i++)for (j=posy2-2;j<posy2+3;j++) ground[i][j]=16+parseInt(Math.random()*1000)%8;                    
                }
            }
            ctr++;
        }
    }
    //4 wasteland districts (only save pos)
    for (r=0;r<4;r++)
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=12)&&(i+j<14))
                {
                    sector[sectorx2][sectory2] = 21;
                    warsectorx[4+r]=sectorx2;
                    warsectory[4+r]=sectory2;
                    okctr++;
                }
            }
            ctr++;
        }
    }
  
    //Sheeps on greenland boni tile
    for (r=0;r<2;r++) // 3 x ranges
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=3+r*3)&&(i+j<4+r*3))
                {
                    sector[sectorx2][sectory2] = 9;
                    okctr++;
                }
            }
            ctr++;
        }
    }
    //Tresures boni tile
    for (r=0;r<3;r++) // 3 x ranges
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=4+r*3)&&(i+j<6+r*3))
                {
                    sector[sectorx2][sectory2] = 15;
                    okctr++;
                }
            }
            ctr++;
        }
    }
    //Iron sources boni tiles
    for (r=0;r<4;r++) // 3 x ranges
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=4+r*3)&&(i+j<6+r*3))
                {
                    sector[sectorx2][sectory2] = 17;
                    okctr++;
                }
            }
            ctr++;
        }
    }
    //Graveyard
    for (r=0;r<3;r++) // 3 x ranges
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=4+r*3)&&(i+j<5+r*3))
                {
                    sector[sectorx2][sectory2] = 10;
                    okctr++;
                }
            }
            ctr++;
        }
    }
    //Tarantula 1x
    for (r=0;r<1;r++) 
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=5+r*3)&&(i+j<6+r*3))
                {
                    sector[sectorx2][sectory2] = 11;
                    okctr++;
                }
            }
            ctr++;
        }
    }
    //Forest of giants 4x
    for (r=0;r<4;r++) 
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=3+r*2)&&(i+j<5+r*2))
                {
                    sector[sectorx2][sectory2] = 12;
                    okctr++;
                }
            }
            ctr++;
        }
    }
   //Black Mountains 2x
    for (r=0;r<2;r++) 
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  ((i+j>=4+r*3)&&(i+j<6+r*3))
                {
                    sector[sectorx2][sectory2] = 13;
                    okctr++;
                }
            }
            ctr++;
        }
    }
       //Diablolo 1x
    for (r=0;r<1;r++) 
    {                
        okctr=0;
        ctr=0;
        while ((okctr<1) && (++ctr<9999))
        {                
            sectorx2=parseInt(Math.random()*1000)%16;
            sectory2=parseInt(Math.random()*1000)%16;
            if (sector[sectorx2][sectory2]==0)
            {
                i=Math.abs(startsectorx-sectorx2);
                if (i>7)i=16-i;
                j=Math.abs(startsectory-sectory2);
                if (j>7)j=16-j;
                if  (i+j==16)
                {
                    sector[sectorx2][sectory2] = 14;
                    okctr++;
                    warsectorx[8]=sectorx2;//Final Wazsector
                    warsectory[8]=sectory2;
                }
            }
            ctr++;
        }
    }

    //Mountains v1
    okctr=0;
    ctr=0;
    while ((okctr<64) && (++ctr<999))
    {                
        sectorx2=parseInt(Math.random()*1000)%16;
        sectory2=parseInt(Math.random()*1000)%16;
                i=Math.abs(startsectorx-sectorx2);
        if (i>7)i=16-i;
        j=Math.abs(startsectory-sectory2);
        if (j>7)j=16-j;   
        lvl = i+j;        
        if ((sector[sectorx2][sectory2]==0)&&(lvl<14))
        {
            sector[sectorx2][sectory2] = 2;
            okctr++;
            posx2=sectorx2*16+8+parseInt(Math.random()*1000)%6;
            posy2=sectory2*16+8+parseInt(Math.random()*1000)%6;
            w2=parseInt(Math.random()*1000)%6;
            h2=parseInt(Math.random()*1000)%6;
            middle[posx2][posy2]=-17-(parseInt(Math.random()*1000)%2)*4;                         
            for (i=0;i<w2;i++)
            {
                middle[posx2][posy2-1-i]=-1-(parseInt(Math.random()*1000)%2)*4;                                                  
                middle[posx2-h2-1][posy2-1-i]=-3-(parseInt(Math.random()*1000)%2)*4;                                                  
            }
            for (i=0;i<h2;i++) 
            {
                middle[posx2-1-i][posy2]=-2-(parseInt(Math.random()*1000)%2)*4;                                                  
                middle[posx2-1-i][posy2-1-w2]=-4-(parseInt(Math.random()*1000)%2)*4;                                                  
                 for (j=1;j<w2+1;j++) middle[posx2-1-i][posy2-j]=-29-parseInt(Math.random()*1000)%4;                         
            }
            middle[posx2][posy2-1-w2]=-20-(parseInt(Math.random()*1000)%2)*4;                           
            middle[posx2-h2-1][posy2]=-18-(parseInt(Math.random()*1000)%2)*4;                           
            middle[posx2-h2-1][posy2-1-w2]=-19-(parseInt(Math.random()*1000)%2)*4;                           
        }
        ctr++;
    }
    //Lake v1
    okctr=0;
    ctr=0;
    while ((okctr<32) && (++ctr<999))
    {
        
        sectorx2=parseInt(Math.random()*1000)%16;
        sectory2=parseInt(Math.random()*1000)%16;
        i=Math.abs(startsectorx-sectorx2);
        if (i>7)i=16-i;
        j=Math.abs(startsectory-sectory2);
        if (j>7)j=16-j;   
        lvl = i+j;        
        if ((sector[sectorx2][sectory2]==0)&&(lvl<9))
        {
            sector[sectorx2][sectory2] = 3;
            okctr++;
            posx2=sectorx2*16+8+parseInt(Math.random()*1000)%6;
            posy2=sectory2*16+8+parseInt(Math.random()*1000)%6;
            w2=2+parseInt(Math.random()*1000)%6;
            h2=2+parseInt(Math.random()*1000)%6;
            ground[posx2][posy2]=64+10+(parseInt(Math.random()*1000)%2)*4;                         
            for (i=0;i<w2;i++)
            {
                ground[posx2][posy2-1-i]=64+2+(parseInt(Math.random()*1000)%2)*4;                                                  
                ground[posx2-h2-1][posy2-1-i]=64+0+(parseInt(Math.random()*1000)%2)*4;                                                  
            }
            for (i=0;i<h2;i++) 
            {
                ground[posx2-1-i][posy2]=64+3+(parseInt(Math.random()*1000)%2)*4;                                                  
                ground[posx2-1-i][posy2-1-w2]=64+1+(parseInt(Math.random()*1000)%2)*4;                                                  
                 for (j=1;j<w2+1;j++) ground[posx2-1-i][posy2-j]=88+parseInt(Math.random()*1000)%8;                         
            }
            ground[posx2][posy2-1-w2]=64+9+(parseInt(Math.random()*1000)%2)*4;                           
            ground[posx2-h2-1][posy2]=64+11+(parseInt(Math.random()*1000)%2)*4;                           
            ground[posx2-h2-1][posy2-1-w2]=64+8+(parseInt(Math.random()*1000)%2)*4;                           
        }
        ctr++;
    }//htg river
    
    //MOBs
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++)
        {                     
            ctr=0;
            ctr2=0;                    
            i=parseInt(Math.abs(startsectorx-si));
            if (i>7)i=16-i;
            j=parseInt(Math.abs(startsectory-sj));
            if (j>7)j=16-j;
            lvl=i+j;//0..14
            if (sector[si][sj]==13) lvl+=3;
            maxctr=1+lvl+parseInt(Math.random()*1000)%lvl;
            if (sector[si][sj]==1) maxctr=1;
            if (sector[si][sj]==2) maxctr-=2;
            if (sector[si][sj]==3) maxctr-=1;
            if (sector[si][sj]==4) maxctr+=1;
            if (sector[si][sj]==5) maxctr+=1;
            if (sector[si][sj]==6) maxctr+=1;
            if (sector[si][sj]==7) maxctr+=2;    
            if (maxctr>1+lvl*2)  maxctr=1+lvl*2;        
            if (sector[si][sj]==9) maxctr*=3;//Sheeps
            //if ((sector[si][sj]!=1) && (maxctr<5)) maxctr=4+parseInt(Math.random()*1000)%3;
            if (sector[si][sj]==11) maxctr=1;//tarantula
            if (sector[si][sj]==14) maxctr=1;//diabolo            
            ctr=0;                                        
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=1+parseInt(Math.random()*1000)%14;
                j=1+parseInt(Math.random()*1000)%14;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    t1=50000;//
                    bOK=false;
                    ctr3=0;
                   // if (sector[si][sj]==1) {bOK=true;t1=60007;}//TEST
                    if (sector[si][sj]==9) {bOK=true;t1=60002;}//Sheep
                    if (sector[si][sj]==10) {bOK=true;t1=60007+parseInt(Math.random()*1000)%(3+parseInt(lvl/5));}//graveyard
                    if (sector[si][sj]==11) {bOK=true;t1=60005;}//tarantula
                    if (sector[si][sj]==14) {bOK=true;t1=60029;}//Final Mob
                    if (sector[si][sj]==19)
                    {
                         bOK=true;
                         t1=60030;//Dwarfs
                         if (lvl==7) t1+=parseInt(Math.random()*1000)%2;//50% black dwarf
                         if (lvl==8) t1++;//100% black dwarf
                    }

                    while (!bOK&&(++ctr3<9999))
                    {
                        typ=parseInt(Math.random()*1000)%mobtypmax;
                        if ((mobtyp[typ]["lvlstart"]<=lvl)&&(mobtyp[typ]["lvlend"]>=lvl)&&(mobtyp[typ]["typ"]!=2))//no dwarfs or quest mobs
                        {
                            if ((mobtyp[typ]["typ"]!=2)||(i%2==0))//statues at a rate of 50%
                            {
                                bOK=true;
                                t1=60000+typ;
                            }
                        }
                    }
                    //t1=60000+34;
                    t2=1;
                    bOK=true;//htg mob width 2
                    //for (k=-2;k<3;k++)
                    //{
                    //    for (l=-2;l<3;l++) if (middle[si*16+i+k][sj*16+j+l]!=0) bOK=false;
                    //}
                    if (bOK)
                    {
                        middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;
                        size=0;
                        if (parseInt(Math.random()*1000)%(32-lvl)==0)
                        {
                            size=parseInt(Math.random()*1000)%(lvl*2);
                        }
                        if (sector[si][sj]==11) size=32;                        
                        if (sector[si][sj]==12) size+=8;
                        if (t1==60022) size+=parseInt(Math.random()*1000)%(4);//Trolls tend to be big
                        if (lvl>12) size+=(lvl-12);
                        if (sector[si][sj]==14) size=64;//Bossmob
                        value[si*16+i][sj*16+j]=size;
                        ctr++;
                    }
                }
            }                                    
        }
    }     
    
    //Berries       htg respawn 0->4  Nature    
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) 
        {                           
            ctr=0;
            ctr2=0;
            maxctr=0;
            if (parseInt(Math.random()*1000)%4==0) maxctr=1;
            if (sector[si][sj]==1) maxctr=3;
            if (sector[si][sj]==2)
            {
                if (parseInt(Math.random()*1000)%8==0) maxctr=1;
            }                    
            if (sector[si][sj]==3) 
            {
                if (parseInt(Math.random()*1000)%3==0) maxctr=1;
            }
            i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>8) maxctr=0;
            t1=1037;
            t2=1;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=3+parseInt(Math.random()*1000)%10;
                j=3+parseInt(Math.random()*1000)%10;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    if ((middle[si*16+i-1][sj*16+j]==0)&&(middle[si*16+i][sj*16+j-1]==0)&&(middle[si*16+i+1][sj*16+j]==0)&&(middle[si*16+i][sj*16+j+1]==0))
                    {
                        middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;
                        value[si*16+i][sj*16+j]=1000;
                        ctr++;
                    }
                }
            }
        }
    }  
      //small lakes
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) 
        { 
            maxctr=parseInt(Math.random()*1000)%2;
            ctr=0;
            ctr2=0;                                     
            if (sector[si][sj]==1) maxctr=0;
            if (sector[si][sj]==2) maxctr=0;
            if (sector[si][sj]==3) maxctr=0;
            if (sector[si][sj]==7) maxctr=0;
             if (sector[si][sj]==9) maxctr++;
            if (sector[si][sj]==12) maxctr=0;
            if (sector[si][sj]==13) maxctr=0;
            if (sector[si][sj]==19) maxctr=0;
            t1=1000+5*16+7;
            t2=8;
            i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>8) maxctr=0;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=12+parseInt(Math.random()*1000)%4;
                j=6+parseInt(Math.random()*1000)%10;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    bOK=true;
                    w2=2+parseInt(Math.random()*1000)%2;
                    h2=2+parseInt(Math.random()*1000)%2;
                    for (k=-w2;k<1;k++)
                    {
                        for (l=-h2-1;l<1;l++) 
                        {
                            if (middle[si*16+i+k][sj*16+j+l]!=0) bOK=false;
                            if (ground[si*16+i+k][sj*16+j+l]>15) bOK=false;
                        }
                    }
                    if (bOK)
                    {
                        posx2=i+si*16;
                        posy2=j+sj*16;
                        ground[posx2][posy2]=64+10+(parseInt(Math.random()*1000)%2)*4;                         
                        for (k=0;k<w2;k++)
                        {
                            ground[posx2][posy2-1-k]=64+2+(parseInt(Math.random()*1000)%2)*4;                                                  
                            ground[posx2-h2-1][posy2-1-k]=64+0+(parseInt(Math.random()*1000)%2)*4;                                                  
                        }
                        for (k=0;k<h2;k++) 
                        {
                            ground[posx2-1-k][posy2]=64+3+(parseInt(Math.random()*1000)%2)*4;                                                  
                            ground[posx2-1-k][posy2-1-w2]=64+1+(parseInt(Math.random()*1000)%2)*4;                                                  
                             for (l=1;l<w2+1;l++) ground[posx2-1-k][posy2-l]=88+parseInt(Math.random()*1000)%8;                         
                        }
                        ground[posx2][posy2-1-w2]=64+9+(parseInt(Math.random()*1000)%2)*4;                           
                        ground[posx2-h2-1][posy2]=64+11+(parseInt(Math.random()*1000)%2)*4;                           
                        ground[posx2-h2-1][posy2-1-w2]=64+8+(parseInt(Math.random()*1000)%2)*4;                           
                        ctr++;
                    }
                }
            }                                    
        }
    }       
    //small Mountains
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) 
        { 
            maxctr=parseInt(Math.random()*1000)%2;
            ctr=0;
            ctr2=0;                                     
            if (sector[si][sj]==1) maxctr=0;
            if (sector[si][sj]==2) maxctr=0;
            if (sector[si][sj]==3) maxctr=0;
            if (sector[si][sj]==7) maxctr=0;
            if (sector[si][sj]==8) maxctr++;
            if (sector[si][sj]==9) maxctr=0;
            if (sector[si][sj]==12) maxctr=0;
            if (sector[si][sj]==13) maxctr+=2;
            if (sector[si][sj]==19) maxctr=0;
              i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>10) maxctr=0;
            t1=1000+5*16+7;
            t2=8;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=6+parseInt(Math.random()*1000)%10;
                j=12+parseInt(Math.random()*1000)%4;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    bOK=true;
                    w2=2+parseInt(Math.random()*1000)%3;
                    h2=2+parseInt(Math.random()*1000)%3;
                    for (k=-w2;k<1;k++)
                    {
                        for (l=-h2-1;l<1;l++) 
                        {
                            if (middle[si*16+i+k][sj*16+j+l]!=0) bOK=false;
                            if (ground[si*16+i+k][sj*16+j+l]>15) bOK=false;
                        }
                    }
                    if (bOK)
                    {
                        posx2=i+si*16;
                        posy2=j+sj*16;
                        if ((parseInt(Math.random()*1000)%4)==0)
                            middle[posx2][posy2]=-25-(parseInt(Math.random()*1000)%4);                         
                        else
                        {
                            middle[posx2][posy2]=-17-(parseInt(Math.random()*1000)%2)*4;                         
                            for (k=0;k<w2;k++)
                            {
                                middle[posx2][posy2-1-k]=-1-(parseInt(Math.random()*1000)%2)*4;                                                  
                                middle[posx2-h2-1][posy2-1-k]=-3-(parseInt(Math.random()*1000)%2)*4;                                                  
                            }
                            for (k=0;k<h2;k++) 
                            {
                                middle[posx2-1-k][posy2]=-2-(parseInt(Math.random()*1000)%2)*4;                                                  
                                middle[posx2-1-k][posy2-1-w2]=-4-(parseInt(Math.random()*1000)%2)*4;                                                  
                                 for (l=1;l<w2+1;l++) middle[posx2-1-k][posy2-l]=-29-parseInt(Math.random()*1000)%4;                         
                            }
                            middle[posx2][posy2-1-w2]=-20-(parseInt(Math.random()*1000)%2)*4;                           
                            middle[posx2-h2-1][posy2]=-18-(parseInt(Math.random()*1000)%2)*4;                           
                            middle[posx2-h2-1][posy2-1-w2]=-19-(parseInt(Math.random()*1000)%2)*4;                           
                        }
                        ctr++;
                        
                    }
                }
            }                                    
        }
    }     
    
      //Buildings
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) 
        { 
            maxctr=0;
            ctr=0;
            ctr2=0;                   
            
            i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            //if (lvl<3) maxctr=parseInt(Math.random()*1000)%(4-lvl);
            if (sector[si][sj]==19) maxctr=6+parseInt(Math.random()*1000)%5;
            t2=1;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=2+parseInt(Math.random()*1000)%12;
                j=2+parseInt(Math.random()*1000)%12;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    t1=30+parseInt(Math.random()*1000)%5;
                    bOK=true;
                    for (k=-2;k<3;k++)
                    {
                        for (l=-1;l<2;l++) if (middle[si*16+i+k][sj*16+j+l]!=0) bOK=false;
                    }
                    if (bOK)
                    {                    
                        middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;
                        //value[si*16+i][sj*16+j]=1000+parseInt(Math.random()*1000)%1000;         
                        ctr++;
                    }
                }
            }                                    
        }
    }                
         
    //Forest
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) 
        {                     
            //Trees      
            ctr=0;
            ctr2=0;
            maxctr=2+parseInt(Math.random()*1000)%20;
            if (sector[si][sj]==1)
            {
                maxctr/=2;                    
                if (maxctr<5) maxctr=5;//make it nice
            }
            if (sector[si][sj]==0)maxctr+=maxctr/2;
            if (sector[si][sj]==8)maxctr/=2;                    
            if (sector[si][sj]==9)maxctr=0;                    
            if (sector[si][sj]==10)maxctr/=3;      
            if (sector[si][sj]==12)maxctr+=10;   
            if (sector[si][sj]==19) maxctr=3;
              i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>11) maxctr=0;           
            t1=42;//Laubwald
            t2=5;
            i=parseInt(Math.abs(startsectorx-si));
            if (i>7)i=16-i;
            j=parseInt(Math.abs(startsectory-sj));
            if (j>7)j=16-j;
            lvl=i+j;//0..14
            if (maxctr%5==1) {t1=50;t2=7;}//Koniferen
            if (maxctr%5==2) {t1=42;t2=15;}//Mischwald
            if (maxctr%5==3) {t1=50;t2=4;if (lvl>7) t2=8;}//Koniferen 2
            if (maxctr%5==4) {t1=53;t2=4;if (lvl>7) t2=8;}////Koniferen 3
            if (sector[si][sj]==3) {t1=38;t2=4+parseInt(Math.random()*1000)%15;}//Palmen am wasser
            if (sector[si][sj]==2) {t1=49;t2=2+parseInt(Math.random()*1000)%5;}//bergwald
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=1+parseInt(Math.random()*1000)%14;
                j=1+parseInt(Math.random()*1000)%14;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    if ((middle[si*16+i-1][sj*16+j]==0)&&(middle[si*16+i][sj*16+j-1]==0)&&(middle[si*16+i+1][sj*16+j]==0)&&(middle[si*16+i][sj*16+j+1]==0))
                    {
                        middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;
                        value[si*16+i][sj*16+j]=800;
                        ctr++;
                    }
                }
            }
            //mushroom     
            maxctr=ctr/7;
            ctr=0;
            ctr2=0;                    
         
            if (sector[si][sj]==1) maxctr=0;
            if (sector[si][sj]==19) maxctr=0;
            if (sector[si][sj]==2)
            {
                maxctr+=1;
            }                    
            if (sector[si][sj]==3) 
            {
                 maxctr-=1;
            }
              i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>12) maxctr=0;
            t1=1000;
            t2=20;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=3+parseInt(Math.random()*1000)%10;
                j=3+parseInt(Math.random()*1000)%10;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    if ((middle[si*16+i-1][sj*16+j]==0)&&(middle[si*16+i][sj*16+j-1]==0)&&(middle[si*16+i+1][sj*16+j]==0)&&(middle[si*16+i][sj*16+j+1]==0))
                    {
                        middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;
                        value[si*16+i][sj*16+j]=100+parseInt(Math.random()*1000)%100;
                        ctr++;
                    }
                }
            }                                    
        }
    }         

    //Stones
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) 
        { 
            maxctr=parseInt(Math.random()*1000)%2;
            ctr=0;
            ctr2=0;                    
         
            if (sector[si][sj]==1) maxctr=0;
            if (sector[si][sj]==2) maxctr+=1;
            if (sector[si][sj]==19) maxctr=2;
             i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>13) maxctr+=2;
            t1=1000+5*16;
            t2=4;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=3+parseInt(Math.random()*1000)%10;
                j=3+parseInt(Math.random()*1000)%10;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    bOK=true;
                    for (k=-2;k<3;k++)
                    {
                        for (l=-2;l<3;l++) if (middle[si*16+i+k][sj*16+j+l]!=0) bOK=false;
                    }
                    if (bOK)
                    {
                        if (lvl>13)                      
                        {
                            if (lvl>14) middle[si*16+i][sj*16+j]=1000+14+3*16;//Sarkophag
                                else  middle[si*16+i][sj*16+j]=1000+13+3*16;//fire bowl
                        } else
                        {
                            middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;//small stones                        
                        }
                        value[si*16+i][sj*16+j]=1000+parseInt(Math.random()*1000)%1000;         
                        ctr++;
                    }
                }
            }                                    
        }
    }         
  
    //Treasures
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) 
        { 
            maxctr=parseInt(Math.random()*1000)%3;
            ctr=0;
            ctr2=0;                    
            if (sector[si][sj]==0) maxctr=0;
            if (sector[si][sj]==1) maxctr=0;
            if (sector[si][sj]==3) maxctr=0;
            if (sector[si][sj]==4) maxctr=0;
            if (sector[si][sj]==5) maxctr=0;
            if (sector[si][sj]==6) maxctr=0;
            if (sector[si][sj]==9) maxctr=0;
            if (sector[si][sj]==8) maxctr+=1;
            if (sector[si][sj]==19) maxctr+=2;
            if (sector[si][sj]==14) maxctr+=10;
            if (sector[si][sj]==15) maxctr+=5;
            i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>13) maxctr+=2;
            t2=1;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=2+parseInt(Math.random()*1000)%12;
                j=2+parseInt(Math.random()*1000)%12;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    k=parseInt(lvl/4)+parseInt(Math.random()*1000)%2;if (k>3) k=3;
                    t1=1000+18*16+k*16;                
                    bOK=true;
                    for (k=-2;k<3;k++)
                    {
                        for (l=-1;l<2;l++) if (middle[si*16+i+k][sj*16+j+l]!=0) bOK=false;
                    }
                    if (bOK)
                    {                    
                        middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;
                        //value[si*16+i][sj*16+j]=1000+parseInt(Math.random()*1000)%1000;         
                        ctr++;
                    }
                }
            }                                    
        }
    }         
    
     //Iron quarz
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) 
        { 
            maxctr=parseInt(Math.random()*1000)%2;
            ctr=0;
            ctr2=0;                    
            if (sector[si][sj]==0) maxctr=0;
            if (sector[si][sj]==1) maxctr=0;
            if (sector[si][sj]==3) maxctr=0;
            if (sector[si][sj]==4) maxctr=0;
            if (sector[si][sj]==5) maxctr=0;
            if (sector[si][sj]==6) maxctr=0;
            if (sector[si][sj]==9) maxctr=0;
            if (sector[si][sj]==8) maxctr+=1;
            if (sector[si][sj]==14) maxctr=0;
            if (sector[si][sj]==17) maxctr+=5;
            if (sector[si][sj]==19) maxctr=1;
            i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>9) maxctr+=2;//lots of iron in wasteland
            if (lvl>14) maxctr=0;//but none in center
            t2=1;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=2+parseInt(Math.random()*1000)%12;
                j=2+parseInt(Math.random()*1000)%12;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    k=parseInt(lvl/5)+parseInt(Math.random()*1000)%2;if (k>2) k=2;
                    t1=1000+15*16+5+k;                
                    bOK=true;
                    for (k=-2;k<3;k++)
                    {
                        for (l=-1;l<2;l++) if (middle[si*16+i+k][sj*16+j+l]!=0) bOK=false;
                    }
                    if (bOK)
                    {                    
                        middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;
                        //value[si*16+i][sj*16+j]=1000+parseInt(Math.random()*1000)%1000;         
                        ctr++;
                    }
                }
            }                                    
        }
    }         
    
  
    
    //Objects
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) if ((parseInt(Math.random()*1000)%8==0)||(sector[si][sj]==19))
        { 
            maxctr=1;
            ctr=0;
            ctr2=0;                    
         
            if (sector[si][sj]==1) maxctr/=2;
            if (sector[si][sj]==2) maxctr+=1;
            if (sector[si][sj]==3) maxctr*=2;
            if (sector[si][sj]==7) maxctr/=2;
            if (sector[si][sj]==19) maxctr+=3;
                         i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>14) maxctr=0;//not in palace

            t1=1000+5*16+7;
            t2=8;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=3+parseInt(Math.random()*1000)%10;
                j=3+parseInt(Math.random()*1000)%10;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    bOK=true;
                    for (k=-2;k<3;k++)
                    {
                        for (l=-2;l<3;l++) if (middle[si*16+i+k][sj*16+j+l]!=0) bOK=false;
                    }
                    if (bOK)
                    {
                        middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;
                        value[si*16+i][sj*16+j]=100+parseInt(Math.random()*1000)%100;
                        ctr++;
                    }
                }
            }                                    
        }
    }     
    //Shrubs
    for (si=0;si<16;si++)
    {
        for (sj=0;sj<16;sj++) 
        { 
            maxctr=parseInt(Math.random()*1000)%6;
            ctr=0;
            ctr2=0;                    
         
            if (sector[si][sj]==1) maxctr/=2;
            if (sector[si][sj]==2) maxctr+=1;
            if (sector[si][sj]==3) maxctr*=2;
            if (sector[si][sj]==7) maxctr/=2;
            if (sector[si][sj]==9) maxctr+=6;
            if (sector[si][sj]==10) maxctr/=2;
            if (sector[si][sj]==19) maxctr=0;
              i=Math.abs(startsectorx-si);
            if (i>7)i=16-i;
            j=Math.abs(startsectory-sj);
            if (j>7)j=16-j;   
            lvl = i+j;        
            if (lvl>12) maxctr=0;
            t1=1000+4*16;
            t2=16;
            while ((ctr<maxctr)&&(++ctr2<9999))
            {
                i=3+parseInt(Math.random()*1000)%10;
                j=3+parseInt(Math.random()*1000)%10;
                if ((ground[si*16+i][sj*16+j]<16)&&(middle[si*16+i][sj*16+j]==0))
                {
                    bOK=true;
                    for (k=-2;k<3;k++)
                    {
                        for (l=-2;l<3;l++) if (middle[si*16+i+k][sj*16+j+l]!=0) bOK=false;
                    }
                    if (bOK)
                    {
                        middle[si*16+i][sj*16+j]=t1+parseInt(Math.random()*1000)%t2;
                        value[si*16+i][sj*16+j]=100;//+parseInt(Math.random()*1000)%100;
                        ctr++;
                    }
                }
            }                                    
        }
    }             
}
